package com.engine.organization.mapper.comp;

import com.engine.organization.entity.comp.po.CompPO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @description: TODO
 * @author:dxfeng
 * @createTime: 2022/05/16
 * @version: 1.0
 */
public interface CompMapper {
    /**
     * 列表查询
     *
     * @return
     */
    List<CompPO> list();

    /**
     * 获取顶级数据
     *
     * @return
     */
    List<CompPO> listParent();

    /**
     * 获取子层级数据
     *
     * @param ids
     * @return
     */
    List<CompPO> listChild(@Param("ids") Collection ids);

    /**
     * 根据ID查询数据
     *
     * @param id
     * @return
     */
    CompPO listById(@Param("id") long id);


    /**
     * 根据No查询数据
     *
     * @param compNo
     * @return
     */
    List<CompPO> listByNo(@Param("compNo") String compNo);


    /**
     * 根据主表id,查询拓展表数据
     *
     * @param tableName
     * @param id
     * @return
     */
    List<Map<String, Object>> listCompExtDT(@Param("tableName") String tableName, @Param("id") long id, @Param("fields") String fields);

    /**
     * 更新禁用标记
     *
     * @param compPO
     * @return
     */
    int updateForbiddenTagById(CompPO compPO);

    /**
     * 批量删除职务信息方案
     *
     * @param ids
     */
    int deleteByIds(@Param("ids") Collection<Long> ids);
}
